﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.5
@EndOfDesignText@
'################################################################
' This class can be used as a replacement for B4i-Map.
' An advantage over the standard class is that all functions contained in B4a-Map are also included here.
'
' Replacement for Standard-B4i-Map
' Class-Name = clsMap
'
' Developer: Filippo
' Version: 1.00
'
'################################################################

Sub Class_Globals
	Type myItem(key As String, Value As Object)
	Private lstItem As List
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	lstItem.Initialize
End Sub

'Clears all items from the map.
Public Sub Clear()
	lstItem.Clear()
End Sub

'Tests whether there is an item with the given key.
Public Sub ContainsKey(Key As String) As Boolean
    For Each mp As myItem In lstItem
        If mp.key.Trim = Key Then
            Return True
        End If
    Next
    Return False
End Sub

'Returns the value of the item with the given key.
Public Sub Get(Key As String) As Object
	For Each mp As myItem In lstItem
		If mp.key.Trim = Key Then
			Return mp.Value
		End If
	Next
	Return ""
End Sub

'Returns the key of the item at the given index.
'GetKeyAt and GetValueAt should be used to iterate over all the items.
'These methods are optimized for iterating over the items in ascending order.
Public Sub GetKeyAt(Index As Int) As Object
    Dim mp As myItem = lstItem.get(Index)
    Return mp.key
End Sub

'Returns the value of the item at the given index.
'GetKeyAt and GetValueAt should be used to iterate over all the items.
'These methods are optimized for iterating over the items in ascending order.
Public Sub GetValueAt(Index As Int) As Object
    Dim mp As myItem = lstItem.get(Index)
    Return mp.Value
End Sub

'Returns an object which can be used to iterate over all the keys with a For Each block.
Public Sub Keys As List
    Dim lst As List
	lst.Initialize
    For Each mp As myItem In lstItem
        lst.Add(mp.key)
    Next
	Return lst
End Sub

'Returns an object which can be used To iterate over all the Values with a For Each block.
Public Sub Values() As List
    Dim lst As List
	lst.Initialize
    For Each mp As myItem In lstItem
        lst.Add(mp.Value)
    Next
    Return lst
End Sub
	
'Removes the item with the given key, if such exists.
'Returns the item removed or null if no matching item was found.
Public Sub Remove(Key As Object)
	For i = 0 To lstItem.Size - 1
		Dim m As myItem = lstItem.Get(i)
		If m.key = Key Then
			lstItem.RemoveAt(i)
			Exit
		End If
	Next
End Sub

'Returns the number of items stored in the map.
Public Sub getSize() As Int
    Return lstItem.Size
End Sub

'Puts a key/value pair in the map, overwriting the previous item with this key (if such exists).
'Returns the previous item with this key or null if there was no such item.
Public Sub Put(Key As String, Value As Object)
	If ContainsKey(Key) Then
		For Each mp As myItem In lstItem
			If mp.key.Trim = Key Then
				mp.Value = Value
				Exit
			End If
		Next
	Else
		Dim mpItem As myItem
		mpItem.Initialize
		mpItem.key = Key
		mpItem.Value = Value
		lstItem.Add(mpItem)
	End If
End Sub

